/*---------------------------------------------------------------------------------------------------------*/
/*                                                                                                         */
/* Copyright(c) 2009 Nuvoton Technology Corp. All rights reserved.                                         */
/* Writed by Nuvoton(SH) CF10.   2013/02/25                                                                */
/*---------------------------------------------------------------------------------------------------------*/
#include <stdio.h>
#include "NUC1xx.h"
#include "DrvGPIO.h"
#include "DrvUART.h"
#include "DrvCAN.h"
#include "DrvSYS.h"
#include "DrvCAN_1.h"

/*----------------------------------------------------------------------------*/
/*  Test Function                                                             */
/*----------------------------------------------------------------------------*/
void CAN_ShowMsg(STR_CANMSG_T* Msg)
{
    uint8_t i;
    printf("Read ID=%8X, IdType=%s, DLC=%d,Data=",Msg->Id,Msg->IdType?"EXT":"STD",Msg->DLC);
    for(i=0;i<Msg->DLC;i++)    
        printf("%02d,",Msg->Data[i]);                                                      
    printf("\n");
}

/*----------------------------------------------------------------------------*/
/*  MAIN function                                                             */
/*----------------------------------------------------------------------------*/
int main (void)
{
    STR_UART_T param;
    STR_CANMSG_T rMsg ;
    uint32_t Cnt = 0 ;

    UNLOCKREG();
    DrvSYS_SetOscCtrl(E_SYS_XTL12M,1);
    DrvSYS_SetOscCtrl(E_SYS_OSC22M,1);
    DrvSYS_Delay(20000);                /* ȴȶʱ */

    DrvSYS_SelectHCLKSource(0);         // HCLK = ⲿʱ(12MHz)

    /* ʼGPIOô */
    DrvGPIO_InitFunction(E_FUNC_UART0);
    param.u32BaudRate        = 115200;
    param.u8cDataBits        = DRVUART_DATABITS_8;
    param.u8cStopBits        = DRVUART_STOPBITS_1;
    param.u8cParity          = DRVUART_PARITY_NONE;
    param.u8cRxTriggerLevel  = DRVUART_FIFO_1BYTES;
    param.u8TimeOut          = 0;
    DrvUART_Open(UART_PORT0, &param);
    printf("UART0 OK !\n") ;

    /*   GPIOB12  CAN  (Ʋ԰) */
    DrvGPIO_Open(E_GPD,14,E_IO_OUTPUT);
    DrvGPIO_ClrBit(E_GPD,14);
    DrvGPIO_Open(E_GPB,12,E_IO_OUTPUT);
    DrvGPIO_ClrBit(E_GPB,12);

    SYSCLK->APBCLK.CAN0_EN  = 1 ;                          // CANʱ
    SYS->IPRSTC2.CAN0_RST   = 1 ;                          // λCAN
    SYS->IPRSTC2.CAN0_RST   = 0 ;
    outpw(&SYS->GPDMFP, inpw(&SYS->GPDMFP) | (0x3<<6));    // GPIOΪCAN
    DrvCAN_Open(500) ;                                     // ò500Kbps
    CAN->CON.TEST = 0 ;                                    // ģʽ
    CAN->CON.DAR  = 0 ;                                    // ʧܲԶط

    CAN_WrtObj(0x151,  0, 0x67452301, 0xefcdab89, 21) ;
    CAN_WrtObj(0x123,  0, 0x67452301, 0xefcdab89, 22) ;
    CAN_WrtObj(0x12,   0, 0x67452301, 0xefcdab89, 23) ;
    CAN_WrtObj(0x1234, 0, 0x67452301, 0xefcdab89, 24) ;

    // ÿ2ѰһǷյ, ÿ20һ
    while(1){
        if(++Cnt >= 10){
            Cnt  = 0 ;
            CAN_TransObj(22) ;                             // Զ֡,
            CAN_TransObj(23) ;                             // Զ֡,
            CAN_TransObj(24) ;                             // Զ֡,
        }
        DrvSYS_Delay(1000000);                             // ʱ1
        DrvSYS_Delay(1000000);                             // ʱ1

        while(CAN->u32IIDR){                               // ȴIDRΪ
            printf("IDR = %d\n", CAN->u32IIDR);
            DrvCAN_ReadMsgObj(CAN->u32IIDR-1, TRUE, &rMsg);
            CAN_ShowMsg(&rMsg) ;
        }
    }
}
