#include "NUC1xx.h"
#include "DrvCAN.h"

static uint32_t  CAN_GetIF(void)
{
    do{
        if(CAN->sMsgObj[0].CREQ.BUSY == 0) return 0 ;   //ȿIF
        if(CAN->sMsgObj[1].CREQ.BUSY == 0) return 1 ;
    }while(1) ;
}
/////////////////////////////////////////////////////////////////////////////////////////
//Input   ID , 18λΪ0,дɻʽ, 18λ,дչʽ
//        Len, ȡֵΧ0~15, ֵΪ0дԶ֡, 0д֡ 
//        Data0, ǰĸֽ, λD3,D2,D1,D0λ
//        Data1, ݺĸֽ, λD7,D6,D5,D4λ
//        ObjNum, к, ȡֵΧ1~32
// ˵:  һ֡д, ж, ûMASK,д0
void CAN_WrtObj(int32_t ID, uint8_t Len, uint32_t Data0, uint32_t Data1, uint32_t ObjNum)
{
    uint32_t  IFNum, FrameType ;

    IFNum      =  CAN_GetIF() ;                         //ȿIF
    CAN->sMsgObj[IFNum].u32CMASK = CAN_CMASK_WRRD | CAN_CMASK_MASK | CAN_CMASK_ARB 
                                 | CAN_CMASK_CONTROL ;
    Len &= 0x0F ;
    if(Len){                                            //֡      
        CAN->sMsgObj[IFNum].u32CMASK |= CAN_CMASK_DATAA | CAN_CMASK_DATAB ; 
        CAN->sMsgObj[IFNum].u32DAT_A1 = (uint16_t)Data0 ;
        CAN->sMsgObj[IFNum].u32DAT_A2 = Data0>>16 ;
        CAN->sMsgObj[IFNum].u32DAT_B1 = (uint16_t)Data1 ;
        CAN->sMsgObj[IFNum].u32DAT_B2 = Data1>>16 ;
    }

    CAN->sMsgObj[IFNum].u32MCON = CAN_MCON_RXIE | CAN_MCON_RMTEN | CAN_MCON_EOB | Len ;  // 

    FrameType  =  Len?0x2000:0 ;
    if(ID & 0xFFFFF800){                                //λ, չID
        CAN->sMsgObj[IFNum].u32ARB1 = ID & 0xFFFF;
        CAN->sMsgObj[IFNum].u32ARB2 = (ID&0x1FF0000)>>16 | FrameType | CAN_ARB2_XTD | CAN_ARB2_MSGVAL ;
    }
    else{                                               //׼ʽ ID     
        CAN->sMsgObj[IFNum].u32ARB1 = 0;
        CAN->sMsgObj[IFNum].u32ARB2 = ((ID&0x7FF)<<2) | FrameType | CAN_ARB2_MSGVAL ;
    }
    CAN->sMsgObj[IFNum].u32MASK1 = 0 ;                  //ûMASK
    CAN->sMsgObj[IFNum].u32MASK2 = 0 ;
    CAN->sMsgObj[IFNum].u32CREQ  = ObjNum ;             //д
}

////ָ///////////////////////////////////////////////////////////////
//Input   ObjNum, к, ȡֵΧ1~32
void CAN_TransObj(uint32_t ObjNum)
{
    uint32_t  IFNum = 2 ;

    IFNum  =  CAN_GetIF() ;                                                  //ȿIF
    CAN->sMsgObj[IFNum].u32CMASK = CAN_CMASK_WRRD | CAN_CMASK_TXRQSTNEWDAT ; //
    CAN->sMsgObj[IFNum].u32CREQ  = ObjNum ;
}
