/*---------------------------------------------------------------------------------------------------------*/
/*                                                                                                         */
/* Copyright(c) 2009 Nuvoton Technology Corp. All rights reserved.                                         */
/* Writed by Nuvoton(SH) CF10    2013/02/25                                                                */
/*---------------------------------------------------------------------------------------------------------*/
#include <stdio.h>
#include "NUC1xx.h"
#include "DrvGPIO.h"
#include "DrvUART.h"
#include "DrvCAN.h"
#include "DrvSYS.h"
#include "DrvCAN_1.h"

int main (void)
{
    uint8_t item=0;
    STR_UART_T param;

    UNLOCKREG();
    DrvSYS_SetOscCtrl(E_SYS_XTL12M,1);
    DrvSYS_SetOscCtrl(E_SYS_OSC22M,1);
    DrvSYS_Delay(20000);                /* ȴȶʱ */

    DrvSYS_SelectHCLKSource(0);         // HCLK = ⲿʱ(12MHz)

    /* ʼGPIOUART0 */
    DrvGPIO_InitFunction(E_FUNC_UART0);
    param.u32BaudRate        = 115200;
    param.u8cDataBits        = DRVUART_DATABITS_8;
    param.u8cStopBits        = DRVUART_STOPBITS_1;
    param.u8cParity          = DRVUART_PARITY_NONE;
    param.u8cRxTriggerLevel  = DRVUART_FIFO_1BYTES;
    param.u8TimeOut          = 0;
    DrvUART_Open(UART_PORT0, &param);
    printf("UART0 OK !\n");

    /* GPB12CAN(Ʋ԰) */
    DrvGPIO_Open(E_GPD,14,E_IO_OUTPUT);
    DrvGPIO_ClrBit(E_GPD,14);
    DrvGPIO_Open(E_GPB,12,E_IO_OUTPUT);
    DrvGPIO_ClrBit(E_GPB,12);

    /* 趨GPIOùΪCAN */
    SYSCLK->APBCLK.CAN0_EN = 1 ;                           //CANʱ 
    SYS->IPRSTC2.CAN0_RST  = 1 ;                           //λCAN
    SYS->IPRSTC2.CAN0_RST  = 0 ;
    outpw(&SYS->GPDMFP, inpw(&SYS->GPDMFP) | (0x3<<6));    //GPIOΪCAN
    DrvCAN_Open(500);                                      //ò500Kbps
    CAN->CON.TEST = 0;                                     //ģʽ
    CAN->CON.DAR  = 0;                                     //ʧܲԶط

    CAN_WrtObj(0x123,  3, 0x67452301, 0xefcdab89, 3) ;     //д
    CAN_WrtObj(0x1234, 8, 0x67452301, 0xefcdab89, 4) ;

    // ÿһ, ObjNum=1ݷ
    do{
        CAN_WrtObj(0x151,  1, item, 0xefcdab89, 1) ;       //¶
        CAN_WrtObj(0x12,   2, ++item, 0xefcdab89, 2) ;     //¶

        DrvSYS_Delay(1000000);                             //ʱ1 
        CAN_TransObj(1) ;                                  //ObjNum=1֡
        printf("ObjNum=1 Data=%d Transfered !\n", item) ;
    }while(1);
}
